--Events
local event = CreateFrame('Frame')
event:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
--Register events
event:RegisterEvent('PLAYER_REGEN_ENABLED')
event:RegisterEvent('PLAYER_REGEN_DISABLED')
--Handle events
function event:PLAYER_REGEN_ENABLED()
    fade(0)
end
function event:PLAYER_REGEN_DISABLED()
   fade(1)
end
--Fade
function fade(mode)
	local frames = {SELECTED_CHAT_FRAME, GeneralDockManager, ChatFrameMenuButton, FriendsMicroButton}
	for _, frame in pairs(frames) do
		if mode == 0 then
			frame:Show()
			UIFrameFadeIn(frame, 1, 0, 1)
		else
			UIFrameFadeOut(frame, 1, 1, 0)
			frame.fadeInfo.finishedArg1 = frame
			frame.fadeInfo.finishedFunc = frame.Hide
		end
	end	
end